#ifndef _H_6DD1BA584D23CBA6FB71DEE0809D61ED_RadarDetection__H_
#define _H_6DD1BA584D23CBA6FB71DEE0809D61ED_RadarDetection__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Point_.h"
#include "geometry_msgs/msg/dds_opensplice/Vector3_.h"


namespace radar_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  RadarDetection_
            {
                ::DDS::UShort detection_id_;
                ::geometry_msgs::msg::dds_::Point_ position_;
                ::geometry_msgs::msg::dds_::Vector3_ velocity_;
                ::DDS::Double amplitude_;
            };

            typedef DDS_DCPSStruct_var<RadarDetection_> RadarDetection__var;
            typedef RadarDetection_& RadarDetection__out;

        }

    }

}

#endif /* _H_6DD1BA584D23CBA6FB71DEE0809D61ED_RadarDetection__H_ */
