#ifndef H_6DD1BA584D23CBA6FB71DEE0809D61ED_RadarDetection_SPLTYPES_H
#define H_6DD1BA584D23CBA6FB71DEE0809D61ED_RadarDetection_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_RadarDetection_.h"
#include "geometry_msgs/msg/dds_opensplice/Point_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/Vector3_SplDcps.h"



extern c_metaObject __RadarDetection__radar_msgs__load (c_base base);

extern c_metaObject __RadarDetection__radar_msgs_msg__load (c_base base);

extern c_metaObject __RadarDetection__radar_msgs_msg_dds___load (c_base base);

extern const char *radar_msgs_msg_dds__RadarDetection__metaDescriptor[];
extern const int radar_msgs_msg_dds__RadarDetection__metaDescriptorArrLength;
extern const int radar_msgs_msg_dds__RadarDetection__metaDescriptorLength;
extern c_metaObject __radar_msgs_msg_dds__RadarDetection___load (c_base base);
struct _radar_msgs_msg_dds__RadarDetection_ ;
extern  v_copyin_result __radar_msgs_msg_dds__RadarDetection___copyIn(c_base base, const struct radar_msgs::msg::dds_::RadarDetection_ *from, struct _radar_msgs_msg_dds__RadarDetection_ *to);
extern  void __radar_msgs_msg_dds__RadarDetection___copyOut(const void *_from, void *_to);
struct _radar_msgs_msg_dds__RadarDetection_ {
    c_ushort detection_id_;
    struct _geometry_msgs_msg_dds__Point_ position_;
    struct _geometry_msgs_msg_dds__Vector3_ velocity_;
    c_double amplitude_;
};

#undef OS_API
#endif
