#ifndef _H_E846B2E1950692BB02484BF73CBA3508_RadarStatus_DCPS_H_
#define _H_E846B2E1950692BB02484BF73CBA3508_RadarStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RadarStatus_.h"


namespace radar_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RadarStatus_TypeSupportInterface;

            typedef RadarStatus_TypeSupportInterface * RadarStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RadarStatus_TypeSupportInterface> RadarStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RadarStatus_TypeSupportInterface> RadarStatus_TypeSupportInterface_out;


            class RadarStatus_DataWriter;

            typedef RadarStatus_DataWriter * RadarStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RadarStatus_DataWriter> RadarStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < RadarStatus_DataWriter> RadarStatus_DataWriter_out;


            class RadarStatus_DataReader;

            typedef RadarStatus_DataReader * RadarStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RadarStatus_DataReader> RadarStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < RadarStatus_DataReader> RadarStatus_DataReader_out;


            class RadarStatus_DataReaderView;

            typedef RadarStatus_DataReaderView * RadarStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RadarStatus_DataReaderView> RadarStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RadarStatus_DataReaderView> RadarStatus_DataReaderView_out;

            struct RadarStatus_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RadarStatus_, struct RadarStatus_Seq_uniq_> RadarStatus_Seq;
            typedef DDS_DCPSSequence_var < RadarStatus_Seq> RadarStatus_Seq_var;
            typedef DDS_DCPSSequence_out < RadarStatus_Seq> RadarStatus_Seq_out;

            class  RadarStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RadarStatus_TypeSupportInterface_ptr _ptr_type;
                typedef RadarStatus_TypeSupportInterface_var _var_type;

                static RadarStatus_TypeSupportInterface_ptr _duplicate (RadarStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RadarStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RadarStatus_TypeSupportInterface () {};
                ~RadarStatus_TypeSupportInterface () {};
            private:
                RadarStatus_TypeSupportInterface (const RadarStatus_TypeSupportInterface &);
                RadarStatus_TypeSupportInterface & operator = (const RadarStatus_TypeSupportInterface &);
            };

            class  RadarStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RadarStatus_DataWriter_ptr _ptr_type;
                typedef RadarStatus_DataWriter_var _var_type;

                static RadarStatus_DataWriter_ptr _duplicate (RadarStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RadarStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RadarStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RadarStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RadarStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RadarStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RadarStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RadarStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RadarStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RadarStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RadarStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RadarStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RadarStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarStatus_& instance_data) = 0;

            protected:
                RadarStatus_DataWriter () {};
                ~RadarStatus_DataWriter () {};
            private:
                RadarStatus_DataWriter (const RadarStatus_DataWriter &);
                RadarStatus_DataWriter & operator = (const RadarStatus_DataWriter &);
            };

            class  RadarStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RadarStatus_DataReader_ptr _ptr_type;
                typedef RadarStatus_DataReader_var _var_type;

                static RadarStatus_DataReader_ptr _duplicate (RadarStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RadarStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RadarStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RadarStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RadarStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarStatus_& instance) = 0;

            protected:
                RadarStatus_DataReader () {};
                ~RadarStatus_DataReader () {};
            private:
                RadarStatus_DataReader (const RadarStatus_DataReader &);
                RadarStatus_DataReader & operator = (const RadarStatus_DataReader &);
            };

            class  RadarStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RadarStatus_DataReaderView_ptr _ptr_type;
                typedef RadarStatus_DataReaderView_var _var_type;

                static RadarStatus_DataReaderView_ptr _duplicate (RadarStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RadarStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RadarStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RadarStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RadarStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RadarStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarStatus_& instance) = 0;

            protected:
                RadarStatus_DataReaderView () {};
                ~RadarStatus_DataReaderView () {};
            private:
                RadarStatus_DataReaderView (const RadarStatus_DataReaderView &);
                RadarStatus_DataReaderView & operator = (const RadarStatus_DataReaderView &);
            };
        }

    }

}

#endif
