#ifndef _H_EE968ECEBAEEEFEFEA955D83C711BA9B_RadarTrackStamped_DCPS_H_
#define _H_EE968ECEBAEEEFEFEA955D83C711BA9B_RadarTrackStamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RadarTrackStamped_.h"


namespace radar_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RadarTrackStamped_TypeSupportInterface;

            typedef RadarTrackStamped_TypeSupportInterface * RadarTrackStamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RadarTrackStamped_TypeSupportInterface> RadarTrackStamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RadarTrackStamped_TypeSupportInterface> RadarTrackStamped_TypeSupportInterface_out;


            class RadarTrackStamped_DataWriter;

            typedef RadarTrackStamped_DataWriter * RadarTrackStamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RadarTrackStamped_DataWriter> RadarTrackStamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < RadarTrackStamped_DataWriter> RadarTrackStamped_DataWriter_out;


            class RadarTrackStamped_DataReader;

            typedef RadarTrackStamped_DataReader * RadarTrackStamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RadarTrackStamped_DataReader> RadarTrackStamped_DataReader_var;
            typedef DDS_DCPSInterface_out < RadarTrackStamped_DataReader> RadarTrackStamped_DataReader_out;


            class RadarTrackStamped_DataReaderView;

            typedef RadarTrackStamped_DataReaderView * RadarTrackStamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RadarTrackStamped_DataReaderView> RadarTrackStamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RadarTrackStamped_DataReaderView> RadarTrackStamped_DataReaderView_out;

            struct RadarTrackStamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RadarTrackStamped_, struct RadarTrackStamped_Seq_uniq_> RadarTrackStamped_Seq;
            typedef DDS_DCPSSequence_var < RadarTrackStamped_Seq> RadarTrackStamped_Seq_var;
            typedef DDS_DCPSSequence_out < RadarTrackStamped_Seq> RadarTrackStamped_Seq_out;

            class  RadarTrackStamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RadarTrackStamped_TypeSupportInterface_ptr _ptr_type;
                typedef RadarTrackStamped_TypeSupportInterface_var _var_type;

                static RadarTrackStamped_TypeSupportInterface_ptr _duplicate (RadarTrackStamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarTrackStamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RadarTrackStamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarTrackStamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarTrackStamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RadarTrackStamped_TypeSupportInterface () {};
                ~RadarTrackStamped_TypeSupportInterface () {};
            private:
                RadarTrackStamped_TypeSupportInterface (const RadarTrackStamped_TypeSupportInterface &);
                RadarTrackStamped_TypeSupportInterface & operator = (const RadarTrackStamped_TypeSupportInterface &);
            };

            class  RadarTrackStamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RadarTrackStamped_DataWriter_ptr _ptr_type;
                typedef RadarTrackStamped_DataWriter_var _var_type;

                static RadarTrackStamped_DataWriter_ptr _duplicate (RadarTrackStamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarTrackStamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RadarTrackStamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarTrackStamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarTrackStamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RadarTrackStamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RadarTrackStamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RadarTrackStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RadarTrackStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RadarTrackStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RadarTrackStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RadarTrackStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RadarTrackStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RadarTrackStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RadarTrackStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RadarTrackStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarTrackStamped_& instance_data) = 0;

            protected:
                RadarTrackStamped_DataWriter () {};
                ~RadarTrackStamped_DataWriter () {};
            private:
                RadarTrackStamped_DataWriter (const RadarTrackStamped_DataWriter &);
                RadarTrackStamped_DataWriter & operator = (const RadarTrackStamped_DataWriter &);
            };

            class  RadarTrackStamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RadarTrackStamped_DataReader_ptr _ptr_type;
                typedef RadarTrackStamped_DataReader_var _var_type;

                static RadarTrackStamped_DataReader_ptr _duplicate (RadarTrackStamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarTrackStamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RadarTrackStamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarTrackStamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarTrackStamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RadarTrackStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RadarTrackStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RadarTrackStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarTrackStamped_& instance) = 0;

            protected:
                RadarTrackStamped_DataReader () {};
                ~RadarTrackStamped_DataReader () {};
            private:
                RadarTrackStamped_DataReader (const RadarTrackStamped_DataReader &);
                RadarTrackStamped_DataReader & operator = (const RadarTrackStamped_DataReader &);
            };

            class  RadarTrackStamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RadarTrackStamped_DataReaderView_ptr _ptr_type;
                typedef RadarTrackStamped_DataReaderView_var _var_type;

                static RadarTrackStamped_DataReaderView_ptr _duplicate (RadarTrackStamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarTrackStamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RadarTrackStamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarTrackStamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarTrackStamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RadarTrackStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RadarTrackStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RadarTrackStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RadarTrackStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarTrackStamped_& instance) = 0;

            protected:
                RadarTrackStamped_DataReaderView () {};
                ~RadarTrackStamped_DataReaderView () {};
            private:
                RadarTrackStamped_DataReaderView (const RadarTrackStamped_DataReaderView &);
                RadarTrackStamped_DataReaderView & operator = (const RadarTrackStamped_DataReaderView &);
            };
        }

    }

}

#endif
