// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from radar_msgs:msg/RadarDetection.idl
// generated code does not contain a copyright notice

#ifndef RADAR_MSGS__MSG__RADAR_DETECTION__STRUCT_HPP_
#define RADAR_MSGS__MSG__RADAR_DETECTION__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'position'
#include "geometry_msgs/msg/point__struct.hpp"
// Member 'velocity'
#include "geometry_msgs/msg/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__radar_msgs__msg__RadarDetection __attribute__((deprecated))
#else
# define DEPRECATED__radar_msgs__msg__RadarDetection __declspec(deprecated)
#endif

namespace radar_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RadarDetection_
{
  using Type = RadarDetection_<ContainerAllocator>;

  explicit RadarDetection_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : position(_init),
    velocity(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->detection_id = 0;
      this->amplitude = 0.0;
    }
  }

  explicit RadarDetection_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : position(_alloc, _init),
    velocity(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->detection_id = 0;
      this->amplitude = 0.0;
    }
  }

  // field types and members
  using _detection_id_type =
    uint16_t;
  _detection_id_type detection_id;
  using _position_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _position_type position;
  using _velocity_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _velocity_type velocity;
  using _amplitude_type =
    double;
  _amplitude_type amplitude;

  // setters for named parameter idiom
  Type & set__detection_id(
    const uint16_t & _arg)
  {
    this->detection_id = _arg;
    return *this;
  }
  Type & set__position(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->position = _arg;
    return *this;
  }
  Type & set__velocity(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->velocity = _arg;
    return *this;
  }
  Type & set__amplitude(
    const double & _arg)
  {
    this->amplitude = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    radar_msgs::msg::RadarDetection_<ContainerAllocator> *;
  using ConstRawPtr =
    const radar_msgs::msg::RadarDetection_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<radar_msgs::msg::RadarDetection_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<radar_msgs::msg::RadarDetection_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      radar_msgs::msg::RadarDetection_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<radar_msgs::msg::RadarDetection_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      radar_msgs::msg::RadarDetection_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<radar_msgs::msg::RadarDetection_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<radar_msgs::msg::RadarDetection_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<radar_msgs::msg::RadarDetection_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__radar_msgs__msg__RadarDetection
    std::shared_ptr<radar_msgs::msg::RadarDetection_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__radar_msgs__msg__RadarDetection
    std::shared_ptr<radar_msgs::msg::RadarDetection_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RadarDetection_ & other) const
  {
    if (this->detection_id != other.detection_id) {
      return false;
    }
    if (this->position != other.position) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    if (this->amplitude != other.amplitude) {
      return false;
    }
    return true;
  }
  bool operator!=(const RadarDetection_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RadarDetection_

// alias to use template instance with default allocator
using RadarDetection =
  radar_msgs::msg::RadarDetection_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace radar_msgs

#endif  // RADAR_MSGS__MSG__RADAR_DETECTION__STRUCT_HPP_
