// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from radar_msgs:msg/RadarStatus.idl
// generated code does not contain a copyright notice

#ifndef RADAR_MSGS__MSG__RADAR_STATUS__STRUCT_HPP_
#define RADAR_MSGS__MSG__RADAR_STATUS__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__radar_msgs__msg__RadarStatus __attribute__((deprecated))
#else
# define DEPRECATED__radar_msgs__msg__RadarStatus __declspec(deprecated)
#endif

namespace radar_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RadarStatus_
{
  using Type = RadarStatus_<ContainerAllocator>;

  explicit RadarStatus_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->curvature = 0;
      this->yaw_rate = 0.0f;
      this->vehicle_speed = 0.0f;
      this->max_track_targets = 0;
      this->raw_data_mode = false;
      this->temperature = 0;
      this->patial_blockage = false;
      this->side_lobe_blockage = false;
    }
  }

  explicit RadarStatus_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->curvature = 0;
      this->yaw_rate = 0.0f;
      this->vehicle_speed = 0.0f;
      this->max_track_targets = 0;
      this->raw_data_mode = false;
      this->temperature = 0;
      this->patial_blockage = false;
      this->side_lobe_blockage = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _curvature_type =
    int16_t;
  _curvature_type curvature;
  using _yaw_rate_type =
    float;
  _yaw_rate_type yaw_rate;
  using _vehicle_speed_type =
    float;
  _vehicle_speed_type vehicle_speed;
  using _max_track_targets_type =
    uint8_t;
  _max_track_targets_type max_track_targets;
  using _raw_data_mode_type =
    bool;
  _raw_data_mode_type raw_data_mode;
  using _temperature_type =
    int8_t;
  _temperature_type temperature;
  using _patial_blockage_type =
    bool;
  _patial_blockage_type patial_blockage;
  using _side_lobe_blockage_type =
    bool;
  _side_lobe_blockage_type side_lobe_blockage;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__curvature(
    const int16_t & _arg)
  {
    this->curvature = _arg;
    return *this;
  }
  Type & set__yaw_rate(
    const float & _arg)
  {
    this->yaw_rate = _arg;
    return *this;
  }
  Type & set__vehicle_speed(
    const float & _arg)
  {
    this->vehicle_speed = _arg;
    return *this;
  }
  Type & set__max_track_targets(
    const uint8_t & _arg)
  {
    this->max_track_targets = _arg;
    return *this;
  }
  Type & set__raw_data_mode(
    const bool & _arg)
  {
    this->raw_data_mode = _arg;
    return *this;
  }
  Type & set__temperature(
    const int8_t & _arg)
  {
    this->temperature = _arg;
    return *this;
  }
  Type & set__patial_blockage(
    const bool & _arg)
  {
    this->patial_blockage = _arg;
    return *this;
  }
  Type & set__side_lobe_blockage(
    const bool & _arg)
  {
    this->side_lobe_blockage = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    radar_msgs::msg::RadarStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const radar_msgs::msg::RadarStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<radar_msgs::msg::RadarStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<radar_msgs::msg::RadarStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      radar_msgs::msg::RadarStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<radar_msgs::msg::RadarStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      radar_msgs::msg::RadarStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<radar_msgs::msg::RadarStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<radar_msgs::msg::RadarStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<radar_msgs::msg::RadarStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__radar_msgs__msg__RadarStatus
    std::shared_ptr<radar_msgs::msg::RadarStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__radar_msgs__msg__RadarStatus
    std::shared_ptr<radar_msgs::msg::RadarStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RadarStatus_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->curvature != other.curvature) {
      return false;
    }
    if (this->yaw_rate != other.yaw_rate) {
      return false;
    }
    if (this->vehicle_speed != other.vehicle_speed) {
      return false;
    }
    if (this->max_track_targets != other.max_track_targets) {
      return false;
    }
    if (this->raw_data_mode != other.raw_data_mode) {
      return false;
    }
    if (this->temperature != other.temperature) {
      return false;
    }
    if (this->patial_blockage != other.patial_blockage) {
      return false;
    }
    if (this->side_lobe_blockage != other.side_lobe_blockage) {
      return false;
    }
    return true;
  }
  bool operator!=(const RadarStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RadarStatus_

// alias to use template instance with default allocator
using RadarStatus =
  radar_msgs::msg::RadarStatus_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace radar_msgs

#endif  // RADAR_MSGS__MSG__RADAR_STATUS__STRUCT_HPP_
